diff --git a/src/odbc/unittests/params.c b/src/odbc/unittests/params.c
index dc382cb..9b17a27 100644
--- a/src/odbc/unittests/params.c
+++ b/src/odbc/unittests/params.c
@@ -3,7 +3,7 @@
 /* Test for store procedure and params */
 /* Test from Tom Rogers */
 
-static char software_version[] = "$Id: params.c,v 1.9 2008/02/08 09:28:03 freddy77 Exp $";
+static char software_version[] = "$Id: params.c,v 1.10 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* SP definition */
@@ -39,21 +39,21 @@ Test(int bind_before)
 	Command(Statement, sp_define);
 
 	if (!bind_before)
-		CHK(SQLPrepare, (Statement, (SQLCHAR *) SP_TEXT, strlen(SP_TEXT)));
+		CHKPrepare((SQLCHAR *) SP_TEXT, strlen(SP_TEXT), "S");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &ReturnCode, 0, &cbReturnCode));
-	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT,  SQL_C_SSHORT, SQL_INTEGER, 0, 0, &InParam,    0, &cbInParam));
-	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &OutParam,   0, &cbOutParam));
+	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &ReturnCode, 0, &cbReturnCode, "S");
+	CHKBindParameter(2, SQL_PARAM_INPUT,  SQL_C_SSHORT, SQL_INTEGER, 0, 0, &InParam,    0, &cbInParam,    "S");
+	CHKBindParameter(3, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &OutParam,   0, &cbOutParam,   "S");
 
 	OutString[0] = '\0';
 	strcpy(OutString, "Test");	/* Comment this line and we get an error!  Why? */
-	CHK(SQLBindParameter, (Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, OutString, 
-	    OUTSTRING_LEN, &cbOutString));
+	CHKBindParameter(4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, OutString, 
+	    OUTSTRING_LEN, &cbOutString, "S");
 
 	if (bind_before)
-		CHK(SQLPrepare, (Statement, (SQLCHAR *) SP_TEXT, strlen(SP_TEXT)));
+		CHKPrepare((SQLCHAR *) SP_TEXT, strlen(SP_TEXT), "S");
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	Command(Statement, "DROP PROC spTestProc");
 
diff --git a/src/odbc/unittests/prepare_results.c b/src/odbc/unittests/prepare_results.c
index 8ebdb4e..da1549e 100644
--- a/src/odbc/unittests/prepare_results.c
+++ b/src/odbc/unittests/prepare_results.c
@@ -2,7 +2,7 @@
 
 /* Test for data format returned from SQLPrepare */
 
-static char software_version[] = "$Id: prepare_results.c,v 1.9 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: prepare_results.c,v 1.10 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -22,9 +22,9 @@ main(int argc, char *argv[])
 	SQLMoreResults(Statement);
 
 	/* test query returns column information for update */
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "update #odbctestdata set i = 20", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "update #odbctestdata set i = 20", SQL_NTS, "S");
 
-	CHK(SQLNumResultCols, (Statement, &count));
+	CHKNumResultCols(&count, "S");
 
 	if (count != 0) {
 		fprintf(stderr, "Wrong number of columns returned. Got %d expected 0\n", (int) count);
@@ -32,30 +32,30 @@ main(int argc, char *argv[])
 	}
 
 	/* test query returns column information */
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "select * from #odbctestdata select * from #odbctestdata", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
 
-	CHK(SQLNumResultCols, (Statement, &count));
+	CHKNumResultCols(&count, "S");
 
 	if (count != 3) {
 		fprintf(stderr, "Wrong number of columns returned. Got %d expected 3\n", (int) count);
 		exit(1);
 	}
 
-	CHK(SQLDescribeCol, (Statement, 1, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable));
+	CHKDescribeCol(1, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable, "S");
 
 	if (type != SQL_INTEGER || strcmp(name, "i") != 0) {
 		fprintf(stderr, "wrong column 1 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
 		exit(1);
 	}
 
-	CHK(SQLDescribeCol, (Statement, 2, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable));
+	CHKDescribeCol(2, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable, "S");
 
 	if (type != SQL_CHAR || strcmp(name, "c") != 0 || (size != 20 && (db_is_microsoft() || size != 40))) {
 		fprintf(stderr, "wrong column 2 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
 		exit(1);
 	}
 
-	CHK(SQLDescribeCol, (Statement, 3, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable));
+	CHKDescribeCol(3, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable, "S");
 
 	if (type != SQL_NUMERIC || strcmp(name, "n") != 0 || size != 34 || digits != 12) {
 		fprintf(stderr, "wrong column 3 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
diff --git a/src/odbc/unittests/prepclose.c b/src/odbc/unittests/prepclose.c
index ff3ca9d..78ae112 100644
--- a/src/odbc/unittests/prepclose.c
+++ b/src/odbc/unittests/prepclose.c
@@ -26,7 +26,7 @@
  * prepare or execute a query. This should fail and return an error message.
  */
 
-static char software_version[] = "$Id: prepclose.c,v 1.3 2006/07/24 09:40:46 freddy77 Exp $";
+static char software_version[] = "$Id: prepclose.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #if HAVE_FSTAT && defined(S_IFSOCK)
@@ -65,7 +65,7 @@ static int
 Test(int direct)
 {
 	char buf[256];
-	SQLRETURN ret;
+	SQLRETURN RetCode;
 	unsigned char sqlstate[6];
 
 	Connect();
@@ -77,20 +77,11 @@ Test(int direct)
 
 	/* force disconnection closing socket */
 	if (direct)
-		ret = SQLExecDirect(Statement, (SQLCHAR *) "SELECT 1", SQL_NTS);
+		CHKExecDirect((SQLCHAR *) "SELECT 1", SQL_NTS, "E");
 	else
-		ret = SQLPrepare(Statement, (SQLCHAR *) "SELECT 1", SQL_NTS);
-	if (ret != SQL_ERROR) {
-		fprintf(stderr, "Error expected\n");
-		return 1;
-	}
+		CHKPrepare((SQLCHAR *) "SELECT 1", SQL_NTS, "E");
 
-	ret = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL);
-	if (ret != SQL_SUCCESS && ret != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Error not set\n");
-		Disconnect();
-		return 1;
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL, "SI");
 	sqlstate[5] = 0;
 	printf("state=%s err=%s\n", (char*) sqlstate, buf);
 	
diff --git a/src/odbc/unittests/preperror.c b/src/odbc/unittests/preperror.c
index 1a8f17a..e3966bb 100644
--- a/src/odbc/unittests/preperror.c
+++ b/src/odbc/unittests/preperror.c
@@ -2,7 +2,7 @@
 
 /* test error on prepared statement, from Nathaniel Talbott test */
 
-static char software_version[] = "$Id: preperror.c,v 1.6 2005/08/14 09:20:53 freddy77 Exp $";
+static char software_version[] = "$Id: preperror.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -10,7 +10,6 @@ main(int argc, char *argv[])
 {
 	SQLLEN cbInString = SQL_NTS;
 	char buf[256];
-	SQLRETURN ret;
 	unsigned char sqlstate[6];
 
 	Connect();
@@ -18,55 +17,27 @@ main(int argc, char *argv[])
 	Command(Statement, "CREATE TABLE #urls ( recdate DATETIME ) ");
 
 	/* test implicit conversion error */
-	if (CommandWithResult(Statement, "INSERT INTO #urls ( recdate ) VALUES ( '2003-10-1 10:11:1 0' )") != SQL_ERROR) {
-		fprintf(stderr, "SQLExecDirect success instead of failing!\n");
-		return 1;
-	}
+	CHKExecDirect((SQLCHAR *) "INSERT INTO #urls ( recdate ) VALUES ( '2003-10-1 10:11:1 0' )", SQL_NTS, "E");
 
 	/* test prepared implicit conversion error */
-	if (!SQL_SUCCEEDED(SQLPrepare(Statement, (SQLCHAR *) "INSERT INTO #urls ( recdate ) VALUES ( ? )", SQL_NTS))) {
-		fprintf(stderr, "SQLPrepare failure!\n");
-		return 1;
-	}
+	CHKPrepare((SQLCHAR *) "INSERT INTO #urls ( recdate ) VALUES ( ? )", SQL_NTS, "SI");
 
 	strcpy(buf, "2003-10-1 10:11:1 0");
-	if (!SQL_SUCCEEDED
-	    (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 128, 0, buf, sizeof(buf), &cbInString))) {
-		fprintf(stderr, "SQLBindParameter failure!\n");
-		return 1;
-	}
-
-	if (SQLExecute(Statement) != SQL_ERROR) {
-		fprintf(stderr, "SQLExecute succeeded instead of failing! (line %d)\n", __LINE__);
-		return 1;
-	}
-
-	ret = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL);
-	if (ret != SQL_SUCCESS && ret != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Error not set (line %d)\n", __LINE__);
-		return 1;
-	}
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 128, 0, buf, sizeof(buf), &cbInString, "SI");
+
+	CHKExecute("E");
+
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL, "SI");
 	printf("err=%s\n", buf);
 
 	/* assure initial state */
 	ResetStatement();
 
 	/* try to prepare and execute a statement with error (from DBD::ODBC test) */
-	ret = SQLPrepare(Statement, (SQLCHAR *) "SELECT XXNOTCOLUMN FROM sysobjects", SQL_NTS);
-
-	if (ret == SQL_SUCCESS)
-		ret = SQLExecute(Statement);
-
-	if (ret != SQL_ERROR) {
-		fprintf(stderr, "SQLExecute succeeded instead of failing! (line %d)\n", __LINE__);
-		return 1;
-	}
+	if (CHKPrepare((SQLCHAR *) "SELECT XXNOTCOLUMN FROM sysobjects", SQL_NTS, "SE") == SQL_SUCCESS)
+		CHKExecute("E");
 
-	ret = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL);
-	if (ret != SQL_SUCCESS && ret != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Error not set (line %d)\n", __LINE__);
-		return 1;
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL, "SI");
 	printf("err=%s\n", buf);
 
 
diff --git a/src/odbc/unittests/print.c b/src/odbc/unittests/print.c
index 45f33dd..d23cea7 100644
--- a/src/odbc/unittests/print.c
+++ b/src/odbc/unittests/print.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: print.c,v 1.19 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: print.c,v 1.20 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static SQLCHAR output[256];
@@ -15,10 +15,7 @@ static const int tds_no_dm = 0;
 static void
 ReadError(void)
 {
-	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL))) {
-		printf("SQLGetDiagRec should not fail\n");
-		exit(1);
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL, "SI");
 	printf("Message: %s\n", output);
 }
 
@@ -27,7 +24,6 @@ test(int odbc3)
 {
 	SQLLEN cnamesize;
 	const char *query;
-	SQLRETURN rc;
 
 	use_odbc_version3 = odbc3;
 
@@ -50,33 +46,28 @@ test(int odbc3)
 	if (odbc3) {
 		CHECK_COLS(0);
 		CHECK_ROWS(-1);
-		rc = SQLFetch(Statement);
-		if (rc != SQL_ERROR)
-			ODBC_REPORT_ERROR("Still data?");
-		CHK(SQLMoreResults, (Statement));
+		CHKFetch("E");
+		CHKMoreResults("S");
 	}
     
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
 
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data?");
+	/* check no data */
+	CHKFetch("No");
 	CHECK_COLS(1);
 	CHECK_ROWS(1);
 
-	/* SQLMoreResults return NO DATA ... */
-	rc = SQLMoreResults(Statement);
-	if (rc != SQL_NO_DATA && rc != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("SQLMoreResults should return NO DATA or SUCCESS WITH INFO");
-
-	if (tds_no_dm && !odbc3 && rc != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLMoreResults should return NO DATA");
-
-	if (odbc3 && rc != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("SQLMoreResults should return SUCCESS WITH INFO");
+	/* SQLMoreResults return NO DATA or SUCCESS WITH INFO ... */
+	if (tds_no_dm && !odbc3)
+		CHKMoreResults("No");
+	else if (odbc3)
+		CHKMoreResults("I");
+	else
+		CHKMoreResults("INo");
 
 	/*
 	 * ... but read error
@@ -103,9 +94,7 @@ test(int odbc3)
 		CHECK_COLS(0);
 		CHECK_ROWS(-1);
 
-		rc = SQLMoreResults(Statement);
-		if (rc != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("SQLMoreResults should return NO DATA");
+		CHKMoreResults("No");
 	}
 
 	/* issue invalid command and test error */
@@ -116,16 +105,10 @@ test(int odbc3)
 	ReadError();
 
 	/* test no data returned */
-	if (SQLFetch(Statement) != SQL_ERROR) {
-		printf("Row fetched ??\n");
-		return 1;
-	}
+	CHKFetch("E");
 	ReadError();
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, output, sizeof(output), &cnamesize) != SQL_ERROR) {
-		printf("Data ??\n");
-		return 1;
-	}
+	CHKGetData(1, SQL_C_CHAR, output, sizeof(output), &cnamesize, "E");
 	ReadError();
 
 	Disconnect();
diff --git a/src/odbc/unittests/putdata.c b/src/odbc/unittests/putdata.c
index 254ac2e..e5cb613 100644
--- a/src/odbc/unittests/putdata.c
+++ b/src/odbc/unittests/putdata.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLPutData */
 
-static char software_version[] = "$Id: putdata.c,v 1.12 2008/10/29 09:56:53 freddy77 Exp $";
+static char software_version[] = "$Id: putdata.c,v 1.13 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char test_text[] =
@@ -18,7 +18,7 @@ main(int argc, char *argv[])
 	const char *p;
 	SQLPOINTER ptr;
 	unsigned char buf[256], *pb;
-	SQLRETURN retcode;
+	SQLRETURN RetCode;
 	int type, lc, sql_type;
 
 	Connect();
@@ -30,7 +30,7 @@ main(int argc, char *argv[])
 	type = SQL_C_CHAR;
 	lc = 1;
 	for (;;) {
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, type, sql_type, 0, 0, (SQLPOINTER) 123, 0, &ind));
+		CHKBindParameter(1, SQL_PARAM_INPUT, type, sql_type, 0, 0, (SQLPOINTER) 123, 0, &ind, "S");
 		/* length required */
 		ind = SQL_LEN_DATA_AT_EXEC(len * lc);
 
@@ -38,10 +38,9 @@ main(int argc, char *argv[])
 		 * test for char 
 		 */
 
-		CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
+		CHKPrepare((SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS, "S");
 
-		if (SQLExecute(Statement) != SQL_NEED_DATA)
-			ODBC_REPORT_ERROR("Wrong result executing statement");
+		CHKExecute("Ne");
 
 		p = test_text;
 		n = 5;
@@ -55,21 +54,20 @@ main(int argc, char *argv[])
 			if (l < n)
 				n = l;
 			if (type == SQL_C_CHAR) {
-				CHK(SQLPutData, (Statement, (char *) p, n));
+				CHKPutData((char *) p, n, "S");
 			} else {
 				SQLWCHAR buf[256];
 				int i;
 				for (i = 0; i < n; ++i)
 					buf[i] = p[i];
-				CHK(SQLPutData, (Statement, (char *) buf, n * lc));
+				CHKPutData((char *) buf, n * lc, "S");
 			}
 			p += n;
 			n *= 2;
 		}
-		CHK(SQLParamData, (Statement, &ptr));
+		CHKParamData(&ptr, "S");
 
-		if (SQLParamData(Statement, &ptr) != SQL_ERROR)
-			ODBC_REPORT_ERROR("Wrong result from SQLParamData");
+		CHKParamData(&ptr, "E");
 
 		/* check state  and reset some possible buffers */
 		Command(Statement, "DECLARE @i INT");
@@ -94,18 +92,16 @@ main(int argc, char *argv[])
 	 * test for binary 
 	 */
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, 0, 0, (SQLPOINTER) 4567, 0, &ind));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, 0, 0, (SQLPOINTER) 4567, 0, &ind, "S");
 	ind = SQL_LEN_DATA_AT_EXEC(254);
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "UPDATE #putdata SET b = ?", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "UPDATE #putdata SET b = ?", SQL_NTS, "S");
 
-	if (SQLExecute(Statement) != SQL_NEED_DATA)
-		ODBC_REPORT_ERROR("Wrong result executing statement");
+	CHKExecute("Ne");
 
 	pb = buf;
 	n = 7;
-	if (SQLParamData(Statement, &ptr) != SQL_NEED_DATA)
-		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
+	CHKParamData(&ptr, "Ne");
 	if (ptr != (SQLPOINTER) 4567)
 		ODBC_REPORT_ERROR("Wrong pointer from SQLParamData");
 	while (pb != (buf + 254)) {
@@ -113,37 +109,33 @@ main(int argc, char *argv[])
 
 		if (l < n)
 			n = l;
-		CHK(SQLPutData, (Statement, (char *) p, n));
+		CHKPutData((char *) p, n, "S");
 		pb += n;
 		n *= 2;
 	}
-	CHK(SQLParamData, (Statement, &ptr));
+	CHKParamData(&ptr, "S");
 
-	if (SQLParamData(Statement, &ptr) != SQL_ERROR)
-		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
+	CHKParamData(&ptr, "E");
 
 	/* check state  and reset some possible buffers */
 	Command(Statement, "DECLARE @i2 INT");
 
 
 	/* test len == 0 case from ML */
-	CHK(SQLFreeStmt, (Statement, SQL_RESET_PARAMS));
+	CHKFreeStmt(SQL_RESET_PARAMS, "S");
 
 	type = SQL_C_CHAR;
 	for (;;) {
-		CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
+		CHKPrepare((SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS, "S");
 
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, type, SQL_LONGVARCHAR, 0, 0, (PTR) 2, 0, &ind));
+		CHKBindParameter(1, SQL_PARAM_INPUT, type, SQL_LONGVARCHAR, 0, 0, (PTR) 2, 0, &ind, "S");
 
 		ind = SQL_LEN_DATA_AT_EXEC(0);
 
-		if ((retcode = SQLExecute(Statement)) != SQL_NEED_DATA) {
-			printf("Wrong result executing statement (retcode=%d)\n", (int) retcode);
-			exit(1);
-		}
-		while (retcode == SQL_NEED_DATA) {
-			retcode = SQLParamData(Statement, &ptr);
-			if (retcode == SQL_NEED_DATA) {
+		CHKExecute("Ne");
+		while (RetCode == SQL_NEED_DATA) {
+			RetCode = SQLParamData(Statement, &ptr);
+			if (RetCode == SQL_NEED_DATA) {
 				SQLPutData(Statement, "abc", 3);
 			}
 		}
diff --git a/src/odbc/unittests/raiserror.c b/src/odbc/unittests/raiserror.c
index 3395ad4..82a5538 100644
--- a/src/odbc/unittests/raiserror.c
+++ b/src/odbc/unittests/raiserror.c
@@ -4,7 +4,7 @@
 
 /* TODO add support for Sybase */
 
-static char software_version[] = "$Id: raiserror.c,v 1.21 2008/02/08 09:28:04 freddy77 Exp $";
+static char software_version[] = "$Id: raiserror.c,v 1.22 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define SP_TEXT "{?=call #tmp1(?,?,?)}"
@@ -61,14 +61,8 @@ TestResult(SQLRETURN result0, int level, const char *func)
 	SqlState[0] = 0;
 	MessageText[0] = 0;
 	NativeError = 0;
-	/* result = SQLError(SQL_NULL_HENV, SQL_NULL_HDBC, Statement, SqlState, &NativeError, MessageText, 1000, &TextLength); */
-	result = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, SqlState, &NativeError, (SQLCHAR *) MessageText, sizeof(MessageText),
-			       &TextLength);
-	printf("Func=%s Result=%d DIAG REC 1: State=%s Error=%d: %s\n", func, (int) result, SqlState, (int) NativeError, MessageText);
-	if (!SQL_SUCCEEDED(result)) {
-		fprintf(stderr, "SQLGetDiagRec error!\n");
-		exit(1);
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, SqlState, &NativeError, (SQLCHAR *) MessageText, sizeof(MessageText), &TextLength, "SI");
+	printf("Func=%s Result=%d DIAG REC 1: State=%s Error=%d: %s\n", func, (int) RetCode, SqlState, (int) NativeError, MessageText);
 
 	if (strstr(MessageText, "An error occurred") == NULL) {
 		fprintf(stderr, "Wrong error returned!\n");
@@ -84,13 +78,11 @@ CheckData(const char *s, int line)
 {
 	char buf[80];
 	SQLLEN ind;
-	SQLRETURN result;
+	SQLRETURN RetCode;
 
-	result = SQLGetData(Statement, 1, SQL_C_CHAR, buf, sizeof(buf), &ind);
-	if (result != SQL_SUCCESS && result != SQL_ERROR)
-		MY_ERROR("SQLFetch invalid result");
+	CHKGetData(1, SQL_C_CHAR, buf, sizeof(buf), &ind, "SE");
 
-	if (result == SQL_ERROR) {
+	if (RetCode == SQL_ERROR) {
 		buf[0] = 0;
 		ind = 0;
 	}
@@ -153,10 +145,10 @@ Test(int level)
 	SQLBindParameter(Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, OutString, OUTSTRING_LEN,
 			 &cbOutString);
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	CheckData("");
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 	CheckData("Here is the first row");
 
 	result = SQLFetch(Statement);
@@ -169,10 +161,8 @@ Test(int level)
 
 		if (result != SQL_NO_DATA)
 			ODBC_REPORT_ERROR("SQLFetch should return NO DATA");
-		result = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, SqlState, &NativeError, (SQLCHAR *) MessageText,
-				       sizeof(MessageText), &TextLength);
-		if (result != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("SQLGetDiagRec should return NO DATA");
+		CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, SqlState, &NativeError, (SQLCHAR *) MessageText,
+				       sizeof(MessageText), &TextLength, "No");
 		result = SQLMoreResults(Statement);
 		expected = level > 10 ? SQL_ERROR : SQL_SUCCESS_WITH_INFO;
 		if (result != expected)
@@ -209,18 +199,17 @@ Test(int level)
 	}
 
 	if (!use_odbc_version3 || !g_nocount) {
-		CHK(SQLMoreResults, (Statement));
+		CHKMoreResults("S");
 		result = SQL_SUCCESS;
 	}
 
 	CheckReturnCode(result, INVALID_RETURN);
 
 	CheckData("");
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 	CheckData("Here is the last row");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLFetch returned failure");
+	CHKFetch("No");
 	CheckData("");
 
 	if (!use_odbc_version3 || g_nocount)
@@ -245,7 +234,6 @@ Test(int level)
 static void
 Test2(int nocount, int second_select)
 {
-	SQLRETURN result;
 	char sql[512];
 
 	g_nocount = nocount;
@@ -257,9 +245,7 @@ Test2(int nocount, int second_select)
 
 	sprintf(sql, create_proc, nocount ? "     SET NOCOUNT ON\n" : "",
 		second_select ? "     SELECT 'Here is the last row' AS LastResult\n" : "");
-	result = CommandWithResult(Statement, sql);
-	if (result != SQL_SUCCESS && result != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Unable to create temporary store");
+	CHKR(CommandWithResult, (Statement, sql), "SNo");
 
 	Test(5);
 
diff --git a/src/odbc/unittests/rebindpar.c b/src/odbc/unittests/rebindpar.c
index d814b1c..87bcbea 100644
--- a/src/odbc/unittests/rebindpar.c
+++ b/src/odbc/unittests/rebindpar.c
@@ -2,29 +2,33 @@
 
 /* Test for executing SQLExecute and rebinding parameters */
 
-static char software_version[] = "$Id: rebindpar.c,v 1.7 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: rebindpar.c,v 1.8 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
+#define SWAP_STMT(b) do { SQLHSTMT xyz = Statement; Statement = b; b = xyz; } while(0)
+
+static HSTMT stmt;
+
 static void
-TestInsert(HSTMT stmt, char *buf)
+TestInsert(char *buf)
 {
 	SQLLEN ind;
 	int l = strlen(buf);
 	char sql[200];
 
 	/* insert some data and test success */
-	CHK(SQLBindParameter, (stmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, l, 0, buf, l, &ind));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, l, 0, buf, l, &ind, "S");
 
 	ind = l;
-	CHK(SQLExecute, (stmt));
+	CHKExecute("S");
 
+	SWAP_STMT(stmt);
 	sprintf(sql, "SELECT 1 FROM #tmp1 WHERE c = '%s'", buf);
 	Command(Statement, sql);
-	CHK(SQLFetch, (Statement));
-	if (SQLFetch(Statement) != SQL_NO_DATA || SQLMoreResults(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "One row expected!\n");
-		exit(1);
-	}
+	CHKFetch("S");
+	CHKFetch("No");
+	CHKMoreResults("No");
+	SWAP_STMT(stmt);
 }
 
 static void
@@ -33,7 +37,6 @@ Test(int prebind)
 	SQLLEN ind;
 	int i;
 	char buf[100];
-	HSTMT stmt;
 
 	/* build a string longer than 80 character (80 it's the default) */
 	buf[0] = 0;
@@ -42,22 +45,25 @@ Test(int prebind)
 
 	Command(Statement, "DELETE FROM #tmp1");
 
-	CHK(SQLAllocStmt, (Connection, &stmt));
+	CHKAllocStmt(&stmt, "S");
 
+	SWAP_STMT(stmt);
 	if (prebind)
-		CHK(SQLBindParameter, (stmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 1, 0, buf, 1, &ind));
+		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 1, 0, buf, 1, &ind, "S");
 
-	CHK(SQLPrepare, (stmt, (SQLCHAR *) "INSERT INTO #tmp1(c) VALUES(?)", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "INSERT INTO #tmp1(c) VALUES(?)", SQL_NTS, "S");
 
-	/* try to insert al empty string, should not fail */
+	/* try to insert an empty string, should not fail */
 	/* NOTE this is currently the only test for insert a empty string using rpc */
 	if (db_is_microsoft())
-		TestInsert(stmt, "");
-	TestInsert(stmt, "a");
-	TestInsert(stmt, "bb");
-	TestInsert(stmt, buf);
-
-	CHK(SQLFreeStmt, (stmt, SQL_DROP));
+		TestInsert("");
+	TestInsert("a");
+	TestInsert("bb");
+	TestInsert(buf);
+
+	CHKFreeStmt(SQL_DROP, "S");
+	Statement = SQL_NULL_HSTMT;
+	SWAP_STMT(stmt);
 }
 
 int
diff --git a/src/odbc/unittests/rownumber.c b/src/odbc/unittests/rownumber.c
index 55eddaf..83fd65c 100644
--- a/src/odbc/unittests/rownumber.c
+++ b/src/odbc/unittests/rownumber.c
@@ -7,21 +7,20 @@
  * TODO make it work and add to Makefile.am
  */
 
-static char software_version[] = "$Id: rownumber.c,v 1.3 2008/02/08 09:28:04 freddy77 Exp $";
+static char software_version[] = "$Id: rownumber.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
 CheckRowNum(int n, int line)
 {
-	SQLRETURN res;
 	SQLUINTEGER value;
 
-	res = SQLGetStmtAttr(Statement, SQL_ATTR_ROW_NUMBER, &value, sizeof(value), NULL);
-	if (res != SQL_SUCCESS) {
-		if (res == SQL_ERROR && n < 0)
-			return;
-		ODBC_REPORT_ERROR("SQLGetStmtAttr failed");
+	if (n < 0) {
+		CHKGetStmtAttr(SQL_ATTR_ROW_NUMBER, &value, sizeof(value), NULL, "E");
+		return;
 	}
+
+	CHKGetStmtAttr(SQL_ATTR_ROW_NUMBER, &value, sizeof(value), NULL, "S");
 	if (value != n) {
 		fprintf(stderr, "Expected %d rows returned %d line %d\n", n, (int) value, line);
 		exit(1);
@@ -32,59 +31,35 @@ CheckRowNum(int n, int line)
 #define CHECK_ROWS(n) CheckRowNum(n,__LINE__)
 
 static void
-NextResults(SQLRETURN expected)
-{
-	if (SQLMoreResults(Statement) != expected) {
-		if (expected == SQL_SUCCESS)
-			fprintf(stderr, "Expected another recordset\n");
-		else
-			fprintf(stderr, "Not expected another recordset\n");
-		exit(1);
-	}
-}
-
-static void
-Fetch(SQLRETURN expected)
-{
-	if (SQLFetch(Statement) != expected) {
-		if (expected == SQL_SUCCESS)
-			fprintf(stderr, "Expected another record\n");
-		else
-			fprintf(stderr, "Not expected another record\n");
-		exit(1);
-	}
-}
-
-static void
 DoTest()
 {
 	int n = 0;
 	static const char query[] = "SELECT * FROM #tmp1 ORDER BY i SELECT * FROM #tmp1 WHERE i < 3 ORDER BY i";
 
 	/* execute a batch command and check row number */
-	CHK(SQLExecDirect, (Statement, (SQLCHAR *) query, SQL_NTS));
+	CHKExecDirect((SQLCHAR *) query, SQL_NTS, "S");
 
 	CHECK_ROWS(-1);
 	printf("Result %d\n", ++n);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
 	CHECK_ROWS(0);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
 	CHECK_ROWS(0);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
 	CHECK_ROWS(0);
-	Fetch(SQL_NO_DATA);
+	CHKFetch("No");
 	CHECK_ROWS(-1);
-	NextResults(SQL_SUCCESS);
+	CHKMoreResults("S");
 	CHECK_ROWS(-1);
 
 	printf("Result %d\n", ++n);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
 	CHECK_ROWS(0);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
 	CHECK_ROWS(0);
-	Fetch(SQL_NO_DATA);
+	CHKFetch("No");
 	CHECK_ROWS(-1);
-	NextResults(SQL_NO_DATA);
+	CHKMoreResults("No");
 	CHECK_ROWS(-1);
 }
 
diff --git a/src/odbc/unittests/rowset.c b/src/odbc/unittests/rowset.c
index ad4b9fa..9e79bbd 100644
--- a/src/odbc/unittests/rowset.c
+++ b/src/odbc/unittests/rowset.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: rowset.c,v 1.3 2008/08/27 07:59:25 freddy77 Exp $";
+static char software_version[] = "$Id: rowset.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -11,24 +11,14 @@ ReadError(void)
 {
 	memset(odbc_err, 0, sizeof(odbc_err));
 	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL))) {
-		printf("SQLGetDiagRec should not fail\n");
-		exit(1);
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL, "SI");
 	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
 }
 
 static void
 test_err(int n)
 {
-	SQLRETURN rc;
-
-	rc = SQLSetStmtAttr(Statement, SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(n), 0);
-	if (rc != SQL_ERROR) {
-		fprintf(stderr, "SQLSetStmtAttr should fail\n");
-		Disconnect();
-		exit(1);
-        }
+	CHKSetStmtAttr(SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(n), 0, "E");
 	ReadError();
 	if (strcmp(odbc_sqlstate, "HY024") != 0) {
 		fprintf(stderr, "Unexpected sql state returned\n");
@@ -49,13 +39,12 @@ main(int argc, char *argv[])
 #endif
 	SQLUSMALLINT statuses[10];
 	char buf[32];
-	SQLRETURN rc;
 
 	use_odbc_version3 = 1;
 	Connect();
 
 	/* initial value should be 1 */
-	CHK(SQLGetStmtAttr, (Statement, SQL_ROWSET_SIZE, &len, sizeof(len), NULL));
+	CHKGetStmtAttr(SQL_ROWSET_SIZE, &len, sizeof(len), NULL, "S");
 	if (len != 1) {
 		fprintf(stderr, "len should be 1\n");
 		Disconnect();
@@ -70,8 +59,8 @@ main(int argc, char *argv[])
 	CheckCursor();
 
 	/* set some correct values */
-	CHK(SQLSetStmtAttr, (Statement, SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(2), 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(1), 0));
+	CHKSetStmtAttr(SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(2), 0, "S");
+	CHKSetStmtAttr(SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(1), 0, "S");
 
 	/* now check that SQLExtendedFetch works as expected */
 	Command(Statement, "CREATE TABLE #rowset(n INTEGER, c VARCHAR(20))");
@@ -86,16 +75,14 @@ main(int argc, char *argv[])
 	}
 
 	ResetStatement();
-	CHK(SQLSetStmtOption, (Statement, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_DYNAMIC));
-	rc = CommandWithResult(Statement, "SELECT * FROM #rowset ORDER BY n");
-	if (!SQL_SUCCEEDED(rc))
-		ODBC_REPORT_ERROR("SQLExecDirect error");
+	CHKSetStmtOption(SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_DYNAMIC, "S");
+	CHKExecDirect((SQLCHAR *) "SELECT * FROM #rowset ORDER BY n", SQL_NTS, "SI");
 
-	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, buf, sizeof(buf), &len));
+	CHKBindCol(2, SQL_C_CHAR, buf, sizeof(buf), &len, "S");
 
 	row_count = 0xdeadbeef;
 	memset(statuses, 0x55, sizeof(statuses));
-	CHK(SQLExtendedFetch, (Statement, SQL_FETCH_NEXT, 1, &row_count, statuses));
+	CHKExtendedFetch(SQL_FETCH_NEXT, 1, &row_count, statuses, "S");
 
 	if (row_count != 1 || statuses[0] != SQL_ROW_SUCCESS || strcmp(buf, "aaaaaaaaa") != 0) {
 		fprintf(stderr, "Invalid result\n");
